#include "driver.h"

int usecount;
int dummy_major;

int register_chrdev (unsigned int major, const char* name)
{
    usecount = 0;
    if (major == 0)
        return MAJOR_NUMBER;
    return major;
}

int unregister_chrdev (unsigned int major, const char* name)
{
    if (MOD_IN_USE)
    {
        ERROR: __CPROVER_assert(0, "MOD_IN_USE in unregister_chrdev");
    }
    else
        return 0;
}

int main ()
{
    int            rval;
    int            size;
    struct file    my_file;
    char          *buffer; /* we do not model this buffer */
    struct inode   inode;

    dummy_major = register_chrdev (0, "dummy");
    inode.i_rdev = dummy_major << MINORBITS;

    init_module ();

    /* assign arbitrary values */
    my_file.f_mode = nondet_uint ();
    my_file.f_pos  = nondet_uint ();

    /* TODO:
     * Add the testing harness for functions
     *    dummy_open
     *    dummy_read
     *    dummy_release
     */

    cleanup_module ();
    unregister_chrdev (dummy_major, "dummy");

    return 0;
}
